gi-gio-2.0.27: Gio bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gio.Interfaces.AsyncResult

Contents

- Exported types
- Methods
  - Overloaded methods
  - getSourceObject
  - getUserData
  - isTagged
  - legacyPropagateError

Description

Provides a base class for implementing asynchronous function results.

Asynchronous operations are broken up into two separate operations which are chained together by a `AsyncReadyCallback`. To begin an asynchronous operation, provide a `AsyncReadyCallback` to the asynchronous function. This callback will be triggered when the operation has completed, and must be run in a later iteration of the [thread-default main context][g-main-context-push-thread-default] from where the operation was initiated. It will be passed a `AsyncResult` instance filled with the details of the operation's success or failure, the object the asynchronous function was started for and any error codes returned. The asynchronous callback function is then expected to call the corresponding "`_finish()`" function, passing the object the function was called for, the `AsyncResult` instance, and (optionally) an `error` to grab any error conditions that may have occurred.

The "`_finish()`" function for an operation takes the generic result (of type `AsyncResult`) and returns the specific result that the operation in question yields (e.g. a `FileEnumerator` for a "enumerate children" operation). If the result or error status of the operation is not needed, there is no need to call the "`_finish()`" function; GIO will take care of cleaning up the result and error information after the `AsyncReadyCallback` returns. You can pass `Nothing` for the `AsyncReadyCallback` if you don't need to take any action at all after the operation completes. Applications may also take a reference to the `AsyncResult` and call "`_finish()`" later; however, the "`_finish()`" function may be called at most once.

Example of a typical asynchronous operation flow:

### C code

    void _theoretical_frobnitz_async (Theoretical         *t,
                                      GCancellable        *c,
                                      GAsyncReadyCallback  cb,
                                      gpointer             u);

    gboolean _theoretical_frobnitz_finish (Theoretical   *t,
                                           GAsyncResult  *res,
                                           GError       **e);

    static void
    frobnitz_result_func (GObject      *source_object,
    		 GAsyncResult *res,
    		 gpointer      user_data)
    {
      gboolean success = FALSE;

      success = _theoretical_frobnitz_finish (source_object, res, NULL);

      if (success)
        g_printf ("Hurray!\n");
      else
        g_printf ("Uh oh!\n");

      ...

    }

    int main (int argc, void *argv[])
    {
       ...

       _theoretical_frobnitz_async (theoretical_data,
                                    NULL,
                                    frobnitz_result_func,
                                    NULL);

       ...
    }

The callback for an asynchronous operation is called only once, and is always called, even in the case of a cancelled operation. On cancellation the result is a `IOErrorEnumCancelled` error.

# {`io`-priority}

Many I/O-related asynchronous operations have a priority parameter, which is used in certain cases to determine the order in which operations are executed. They are not used to determine system-wide I/O scheduling. Priorities are integers, with lower numbers indicating higher priority. It is recommended to choose priorities between `PRIORITY_LOW` and `PRIORITY_HIGH`, with `PRIORITY_DEFAULT` as a default.

Synopsis

- newtype AsyncResult = AsyncResult (ManagedPtr AsyncResult)
- class (GObject o, IsDescendantOf AsyncResult o) => IsAsyncResult o
- toAsyncResult :: (MonadIO m, IsAsyncResult o) => o -> m AsyncResult
- asyncResultGetSourceObject :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> m (Maybe Object)
- asyncResultGetUserData :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> m (Ptr ())
- asyncResultIsTagged :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> Ptr () -> m Bool
- asyncResultLegacyPropagateError :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> m ()

# Exported types

newtype AsyncResult Source #

Memory-managed wrapper type.

Constructors

AsyncResult (ManagedPtr AsyncResult) |

#### Instances

Instances details

Eq AsyncResult Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult Methods (==) :: AsyncResult -> AsyncResult -> Bool # (/=) :: AsyncResult -> AsyncResult -> Bool #
GObject AsyncResult Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult
TypedObject AsyncResult Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult Methods glibType :: IO GType Source #
ManagedPtrNewtype AsyncResult Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult Methods toManagedPtr :: AsyncResult -> ManagedPtr AsyncResult Source #
IsGValue AsyncResult Source # | Convert `AsyncResult` to and from `GValue` with `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Interfaces.AsyncResult Methods toGValue :: AsyncResult -> IO GValue Source # fromGValue :: GValue -> IO AsyncResult Source #
HasParentTypes AsyncResult Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult
type ParentTypes AsyncResult Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult type ParentTypes AsyncResult = '[Object]

class (GObject o, IsDescendantOf AsyncResult o) => IsAsyncResult o Source #

Type class for types which can be safely cast to `AsyncResult`, for instance with `toAsyncResult`.

#### Instances

Instances details

(GObject o, IsDescendantOf AsyncResult o) => IsAsyncResult o Source # |
Instance details Defined in GI.Gio.Interfaces.AsyncResult

toAsyncResult :: (MonadIO m, IsAsyncResult o) => o -> m AsyncResult Source #

Cast to `AsyncResult`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

## Overloaded methods

## getSourceObject

asyncResultGetSourceObject Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `res`: a `AsyncResult`
-> m (Maybe Object) | Returns: a new reference to the source object for the `res`, or `Nothing` if there is none.

Gets the source object from a `AsyncResult`.

## getUserData

asyncResultGetUserData Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `res`: a `AsyncResult`.
-> m (Ptr ()) | Returns: the user data for `res`.

Gets the user data from a `AsyncResult`.

## isTagged

asyncResultIsTagged Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `res`: a `AsyncResult`
-> Ptr () | `sourceTag`: an application-defined tag
-> m Bool | Returns: `True` if `res` has the indicated `sourceTag`, `False` if not.

Checks if `res` has the given `sourceTag` (generally a function pointer indicating the function `res` was created by).

Since: 2.34

## legacyPropagateError

asyncResultLegacyPropagateError Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `res`: a `AsyncResult`
-> m () | (Can throw `GError`)

If `res` is a `SimpleAsyncResult`, this is equivalent to `simpleAsyncResultPropagateError`. Otherwise it returns `False`.

This can be used for legacy error handling in async *`_finish()` wrapper functions that traditionally handled `SimpleAsyncResult` error returns themselves rather than calling into the virtual method. This should not be used in new code; `AsyncResult` errors that are set by virtual methods should also be extracted by virtual methods, to enable subclasses to chain up correctly.

Since: 2.34